// Copyright 2016 The Gorilla WebSocket Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

// +build go1.5

package server

import "io"

func (c *Conn) read(n int) ([]byte, error) {
	p, err := c.BuffReader.Peek(n)
	if err == io.EOF {
		err = errUnexpectedEOF
	}
	c.BuffReader.Discard(len(p))
	return p, err
}
